﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
namespace SentinelApi.En
{
    public interface ISentinelAPI
    {
        #region 5.0 members
        ApiVersionResult GetVersion();
      
        ApiTokenResult GenerateSystemKey50(string systemname, string systempassword);
        ApiTokenResult SystemLogIn50(string systemname, string encsystemkey, string systemversion);
        ApiTokenResult GenerateSystemClientKey50(string systemlogintoken, string clientid);
        ApiTokenResult SystemClientLogIn50(string systemclientkey);//bundet til klient og IP

        ApiResult LogIn50(string systemlogintoken, string clientid, string orgcode, string initials);
        ApiResult LogOut50(string systemlogintoken, string clientid, string orgcode, string initials);
        ApiResult LogInSession50(string systemlogintoken, string clientid, string orgcode, string initials, string sessionid);
        ApiResult LogOutSession50(string systemlogintoken, string clientid, string orgcode, string initials, string sessionid);

        ApiResult UpdatePatient50(string systemlogintoken, string clientid, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string firstname, string lastname, string regioncode, string email);

        ApiResult InsertAnalysis50(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string code, string coderesponsible, string codetext, string producercode, string producer, int _operator, string value, string unit, string reffrom, string refto, string reftext, string abnorm, string samplingsdatetime, string comments);
        ApiResult InsertDiagnosis50(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string processrole, string icpccode, string icpccodetext, string icpcsource, string icd10code, string icd10codetext, string icd10source);
        ApiResult InsertMedicine50(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string itemnumber, string atccode, string form, string name, float strength, string strengthunit, string strengthtext, string package, string dosecode, string doseshort, string doselong, int doseperioddays, string indcode, string indication, int numberofpackages, int numberofiterations, int iteintervaldays);
        ApiResult InsertService50(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string servicecode, string servicecodetext);
        ApiResult InsertCorrespondence50(string systemlogintoken, string clientid, string localid, string orgcode, string initials, bool outgoing, string correspondence, string processid);
        ApiResult InsertTreatment50(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string code, string coderesponsible, string codetext, string comments);
        ApiResult InsertNote50(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string processrole, string notetype, string header, string note);

        ApiResult RegisterEvent50(string systemlogintoken, string clientid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string eventcode, string eventdata);
        ApiResult ClosedJournal50(string systemlogintoken, string clientid, string orgcode, string initials, string gporgcode, string gpinitials, string cpr);
        ApiResult OpenedJournal50(string systemlogintoken, string clientid, string orgcode, string initials, string gporgcode, string gpinitials, string cpr);
        ApiResult ChangedJournal50(string systemlogintoken, string clientid, string orgcode, string initials, string gporgcode, string gpinitials, string cpr);


        ApiResult DeleteAnalysis50(string systemlogintoken, string clientid, string localid);
        ApiResult DeleteMedicine50(string systemlogintoken, string clientid, string localid);
        ApiResult DeleteDiagnosis50(string systemlogintoken, string clientid, string localid);
        ApiResult DeleteService50(string systemlogintoken, string clientid, string localid);
        ApiResult DeleteCorrespondence50(string systemlogintoken, string clientid, string localid);
        ApiResult DeleteTreatment50(string systemlogintoken, string clientid, string localid);
        ApiResult DeleteNote50(string systemlogintoken, string clientid, string localid);

        ApiResult CloseSentinel50(string systemlogintoken, string clientid);

        ApiMenuResult GetMenu50(string systemlogintoken, string clientid, string orgcode, string initials, string cpr);

        ApiResult ExecuteAction50(string systemlogintoken, string clientid, string action);

        ApiActionsResult GetActions50(string systemlogintoken, string clientid, bool? autohandlemessages);
        ApiWebClientResult GetWebClientUrl50(string systemlogintoken, string clientid, bool? autohandleactions);

        #endregion

        #region  5.1 members
        ApiResult InsertDiagnosis51(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, string processrole, bool @private, string icpccode, string icpccodetext, string icpcsource, string icd10code, string icd10codetext, string icd10source);
        ApiResult InsertProcess51(string systemlogintoken, string clientid, string localid, string eventdatetime, string orgcode, string initials, string gporgcode, string gpinitials, string cpr, string processid, bool @private, string enddatetime);
        ApiResult DeleteProcess51(string systemlogintoken, string clientid, string localid);

        #endregion

    }

}
